/////////////////////////////////////////////////////////////
// Flash Plugin and Player
// Copyright (C) 1998 Olivier Debon
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
///////////////////////////////////////////////////////////////
#ifndef _TEXT_H_
#define _TEXT_H_

#include "swf.h"
#include "font.h"
#include "character.h"

struct Glyph {
	long	index;
	long	xAdvance;
};

struct TextRecord {

	// Normal text record
	Glyph		*glyphs;
	long		 nbGlyphs;

	// Control text record
	TextFlags	 flags;
	SwfFont		*font;
	long		 fontHeight;
	Color		 color;
	long		 xOffset;
	long		 yOffset;

	TextRecord *next;
};

class Text : public Character {

	long		 xMin,yMin,xMax,yMax;
	Matrix		 textMatrix;
	TextRecord	*textRecords;	// List

public:
	Text(long id);
	~Text();

	void	 setTextBoundary(long x1, long y1, long x2, long y2);
	void	 setTextMatrix(Matrix m);
	void	 addTextRecord(TextRecord *tr);
	int	 execute(GraphicDevice *gd, Matrix *matrix, Cxform *cxform);
	void	 getRegion(GraphicDevice *gd, Matrix *matrix, unsigned char id);
};

#endif /* _TEXT_H_ */
